Brute-force based on hints

 I looked at the hints for this one: https://leetcode.com/problems/lexicographically-smallest-string-after-applying-operations/

1625. Lexicographically Smallest String After Applying Operations
Medium

You are given a string s of even length consisting of digits from 0 to 9, and two integers a and b.

You can apply either of the following two operations any number of times and in any order on s:

  • Add a to all odd indices of s (0-indexed). Digits post 9 are cycled back to 0. For example, if s = "3456" and a = 5s becomes "3951".
  • Rotate s to the right by b positions. For example, if s = "3456" and b = 1s becomes "6345".

Return the lexicographically smallest string you can obtain by applying the above operations any number of times on s.

A string a is lexicographically smaller than a string b (of the same length) if in the first position where a and b differ, string a has a letter that appears earlier in the alphabet than the corresponding letter in b. For example, "0158" is lexicographically smaller than "0190" because the first position they differ is at the third letter, and '5' comes before '9'.

 

Example 1:

Input: s = "5525", a = 9, b = 2
Output: "2050"
Explanation: We can apply the following operations:
Start:  "5525"
Rotate: "2555"
Add:    "2454"
Add:    "2353"
Rotate: "5323"
Add:    "5222"
​​​​​​​Add:    "5121"
​​​​​​​Rotate: "2151"
​​​​​​​Add:    "2050"​​​​​​​​​​​​
There is no way to obtain a string that is lexicographically smaller then "2050".

Example 2:

Input: s = "74", a = 5, b = 1
Output: "24"
Explanation: We can apply the following operations:
Start:  "74"
Rotate: "47"
​​​​​​​Add:    "42"
​​​​​​​Rotate: "24"​​​​​​​​​​​​
There is no way to obtain a string that is lexicographically smaller then "24".

Example 3:

Input: s = "0011", a = 4, b = 2
Output: "0011"
Explanation: There are no sequence of operations that will give us a lexicographically smaller string than "0011".

Example 4:

Input: s = "43987654", a = 7, b = 3
Output: "00553311"

 

Constraints:

  • 2 <= s.length <= 100
  • s.length is even.
  • s consists of digits from 0 to 9 only.
  • 1 <= a <= 9
  • 1 <= b <= s.length - 1
Accepted
2,134
Submissions
3,993

The hints explicitly tell you to be brave and try brute-force. So I did. Keep track of all the variations, rotate & add in the same recursion, hope for the best. Apparently it works. Code is down below, cheers, ACC.


public class Solution {
    public string FindLexSmallestString(string s, int a, int b)
    {
        string smallest = s;
        Process(s, a, b, new Hashtable(), ref smallest);
        return smallest;
    }

    private void Process(string s, int a, int b, Hashtable allCombinations, ref string smallest)
    {
        if (String.IsNullOrEmpty(s)) return;

        if (allCombinations.ContainsKey(s.GetHashCode())) return;

        allCombinations.Add(s.GetHashCode(), true);
        if (IsSmallerThan(s, smallest)) smallest = s;

        //Rotate
        StringBuilder sb = new StringBuilder(s);
        for (int i = 0; i < s.Length; i++)
        {
            sb[(i + b) % s.Length] = s[i];
        }
        if (!allCombinations.ContainsKey(sb.ToString().GetHashCode())) Process(sb.ToString(), a, b, allCombinations, ref smallest);

        //Add
        string temp = "";
        for (int i = 0; i < s.Length; i++)
        {
            if (i % 2 == 0) temp += s[i].ToString();
            else temp += (((int)(s[i] - '0') + a) % 10).ToString();
        }
        if (!allCombinations.ContainsKey(temp.GetHashCode())) Process(temp, a, b, allCombinations, ref smallest);
    }

    private bool IsSmallerThan(string str1, string str2)
    {
        for (int i = 0; i < str1.Length; i++)
        {
            if (str1[i] < str2[i]) return true;
            if (str1[i] > str2[i]) return false;
        }
        return false;
    }
}

Comments

Popular posts from this blog

Count Binary Substrings

Count Vowels Permutation: Standard DP

Maximum Number of Balloons